/**
 * @file   Background.js
 * @author simpart
 */

mofron.comp.Background = class extends mofron.comp.Base {
    
    initContents (vd, prm) {
        try {
            var div = new mofron.util.Vdom('div');
            div.setStyle('height'    , '100%');
            div.setStyle('width'     , '100%');
            div.setStyle('position'  , 'fixed');
            vd.addChild(div);
        } catch (e) {
            console.error(e.stack);
            throw e;
        }
    }
    
    getTarget () {
        try {
            return this.getVdom().getChild(0);
        } catch (e) {
            console.error(e.stack);
            throw e;
        }
    }
    
    color (clr) {
        try {
            var _clr = (clr === undefined) ? null : clr;
            if (null === _clr) {
                return this.getStyle().getStyle('background');
            }
            if ('object' != (typeof _clr)) {
                throw new Error('invalid parameter');
            }
            this.style('background', _clr.getStyle());
        } catch (e) {
            console.error(e.stack);
            throw e;
        }
    }
    
    shadow (val) {
        try {
            var _val = (val === undefined) ? null : val;
            if (null === _val) {
                return this.getStyle().getStyle('box-shadow');
            }
            if ('number' != (typeof _val)) {
                throw new Error('invalid parameter');
            }
            this.style('box-shadow', '0px '+ val/2 + 'px '+ val +'px '+ '0px gray');
        } catch (e) {
            console.error(e.stack);
            throw e;
        }
    }
}
